#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		perlvers	%(perl -v|grep "This"|cut -d'(' -f2 |cut -d ')' -f1|sed -e "s/v//")
%define		appname		%{name}
#-----------------------------------------------------------------------------
Name		:	nginx
Version		:	1.25.3
Release		:	16.2.0.rel%{?dist}

Summary		:	A high performance web server and reverse proxy server

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	BSD-2-Clause
URL		:	https://nginx.org

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	GeoIP-devel
BuildRequires	:	gnupg
BuildRequires	:	libgd-devel
BuildRequires	:	perl

Conflicts	:	httpd
#-----------------------------------------------------------------------------
%description
Nginx is a web server and a reverse proxy server
for HTTP, SMTP, POP3 and IMAP protocols, with a
strong focus on high concurrency, performance and
low memory usage.
 
#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%dir %{_sysconfdir}/%{name}/conf.d
%config (noreplace) %{_sysconfdir}/logrotate.d/%{name}.lr
%{_sysconfdir}/%{name}/fastcgi.conf
%{_sysconfdir}/%{name}/fastcgi.conf.default
%{_sysconfdir}/%{name}/fastcgi_params
%{_sysconfdir}/%{name}/fastcgi_params.default
%{_sysconfdir}/%{name}/koi-utf
%{_sysconfdir}/%{name}/koi-win
%{_sysconfdir}/%{name}/mime.types
%{_sysconfdir}/%{name}/mime.types.default
%{_sysconfdir}/%{name}/%{name}.conf
%{_sysconfdir}/%{name}/%{name}.conf.default
%{_sysconfdir}/%{name}/scgi_params
%{_sysconfdir}/%{name}/scgi_params.default
%{_sysconfdir}/%{name}/uwsgi_params
%{_sysconfdir}/%{name}/uwsgi_params.default
%{_sysconfdir}/%{name}/win-utf
%{_sysconfdir}/rc.d/init.d/%{name}
%{_sbindir}/%{name}
%{_libdir}/%{name}/modules/*.so
%{_libdir}/perl5/%{perlvers}/site_perl/%{name}.pm
%{_libdir}/perl5/%{perlvers}/site_perl/auto/%{name}/%{name}.so
%dir %{_var}/log/%{name}/
%{_datadir}/%{name}/html/*.html
%{_mandir}/man3/%{name}.3.gz

#-----------------------------------------------------------------------------
%pre
#after upgrade or remove
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{appname}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{appname}
    /usr/sbin/useradd 				\
	-r					\
	-c "Apache Server"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{appname}				\
	-s /sbin/nologin			\
	-d %{_sysconfdir}/%{name}		\
	%{appname}
    fi
  fi

%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#-----------------------------------------------------------------------------
%postun
if [ "$1" = 0 ]; then
  /usr/sbin/userdel %{appname}
  fi

%post
/sbin/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%prep
%setup -q
tar xf %{SOURCE1}

#include nginx.conf.d directrory with configuration file
sed -i							\
 -e "/#gzip  on;/a					\
  \ \ \ \ include %{_sysconfdir}/%{name}/conf.d/*.conf;"\
 conf/%{name}.conf

#-----------------------------------------------------------------------------
#building application
%build

./configure						\
        --prefix=%{_datadir}/%{name}			\
	--sbin-path=%{_sbindir}/%{name}			\
	--modules-path=%{_libdir}/%{name}/modules	\
    	--conf-path=%{_sysconfdir}/%{name}/%{name}.conf	\
	--pid-path=/run/%{name}/%{name}.pid		\
	--error-log-path=%{_var}/log/%{name}/error.log	\
	--http-log-path=%{_var}/log/%{name}/access.log	\
	--modules-path=%{_libdir}/nginx/modules		\
	--user=%{appname}				\
	--group=%{appname}				\
	--with-compat					\
	--with-debug					\
	--with-file-aio					\
	--with-http_addition_module			\
	--with-http_auth_request_module			\
	--with-http_dav_module				\
	--with-http_degradation_module			\
	--with-http_flv_module				\
	--with-http_geoip_module=dynamic		\
	--with-stream_geoip_module=dynamic		\
	--with-http_perl_module=dynamic 		\
	--with-http_image_filter_module=dynamic		\
	--with-http_xslt_module=dynamic 		\
	--with-http_gunzip_module			\
	--with-http_gzip_static_module			\
	--with-http_mp4_module				\
	--with-http_random_index_module			\
	--with-http_realip_module			\
	--with-http_secure_link_module			\
	--with-http_slice_module			\
	--with-http_ssl_module				\
	--with-http_stub_status_module			\
	--with-http_sub_module				\
	--with-http_v2_module				\
	--with-mail=dynamic				\
	--with-mail_ssl_module				\
	--with-pcre-jit					\
	--with-stream=dynamic				\
	--with-stream_geoip_module			\
	--with-stream_realip_module			\
	--with-stream_ssl_module			\
	--with-stream_ssl_preread_module		\
	--with-threads					\


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

#configuration directory
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}/conf.d/

#installing httpd starting/stopping script
%{__mkdir_p}	%{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#installing logrotate file
%{__mkdir_p}	%{buildroot}%{_var}/log/%{name}
%{__mkdir_p}	%{buildroot}%{_sysconfdir}/logrotate.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}.lr			\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{name}.lr

#-----------------------------------------------------------------------------
find %{buildroot} -name ".packlist" | xargs rm -f
find %{buildroot} -name "perllocal.pod" | xargs rm -f

#-----------------------------------------------------------------------------
%changelog
